/*###########################################################################
#                                                                           #
#    		               wb_t@C								#
#                                                                           #
###########################################################################*/
#ifndef __PROJECT_H__
#define __PROJECT_H__

#define version PSTR("version 0.01b")
#define IR_LOOP 5						/* ԊOˉ(PŔȂꍇ̕ی̂߁j*/

/*									*/
/* et@CCN[h			*/
/*									*/
#include <string.h>
#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include <util/crc16.h>

#include "timer.h"
#include "sg12864a.h"
#include "keys.h"
#include "imagedata.h"

#define IR_COUNT 8						/* ǗIRf[^				*/
#define PG_COUNT 50						/* ǗvO				*/

/* ǗJnN								*/
/* Ŏw肵t135N܂ŊǗ\	*/
/* Ŏw肵tO̓t͊Ǘs\	*/
#define START_YEAR 2010
#define START_MONTH 1
#define START_DAY 1

/* t\̒`(8bytes)		*/
typedef struct TIME_t {
	uint16_t year;							/* 							*/
	uint8_t month;							/* 							*/
	uint8_t day;							/* 							*/
	uint8_t hour;							/* 							*/
	uint8_t minute;							/* 							*/
	uint8_t second;							/* b							*/
	uint8_t wday;							/* j							*/
} TIME;

/* IR\̒`(46bytes)			*/
typedef struct IR_t {
	uint16_t Start_Ltime;				/* X^[gpXL(JEg)	*/
	uint16_t Start_Htime;				/* X^[gpXH(JEg)	*/
	uint16_t Dat0_Ltime;				/* f[^OpXL(JEg)	*/
	uint16_t Dat0_Htime;				/* f[^OpXH(JEg)	*/
	uint16_t Dat1_Ltime;				/* f[^PpXL(JEg)	*/
	uint16_t Dat1_Htime;				/* f[^PpXH(JEg)	*/
	uint16_t Stop_Htime;				/* XgbvpXH(JEg)	*/
	uint8_t bitLength;					/* IRf[^rbg(0`254)			*/
	uint8_t datas[31];					/* IRf[^							*/
} IR;

/* vO\(6bytes)			*/
typedef struct PG_t {
	uint8_t active  :  1 ;				/* 0: 1:L					*/
	uint8_t type    :  2 ;				/* 0:T 1:w				*/
	uint8_t irIndex :  5 ;				/* IRCfbNXԍ				*/
	uint16_t year   : 12 ;				/* 								*/
	uint8_t month   :  4 ;				/*  1 ` 12						*/
	uint8_t day     :  5 ;				/*  1 `							*/
	uint8_t hour    :  5 ;				/*  0 ` 23						*/
	uint8_t minute  :  6 ;				/*  0 ` 59						*/
	uint8_t week;						/* j(Bit0`6:`y)				*/
} PG;

/*									*/
/* EEP-ROM }bv\(1024bytes)	*/
/*									*/
typedef struct EEPMAP_t {
	uint16_t crc;						/* CRCl							*/
	char id[16];						/* ʕ "nPYO IR-TIMER  "		*/
	IR ir[IR_COUNT];					/* IRf[^\					*/
	PG pg[PG_COUNT];					/* ^C}[vO\			*/
	uint8_t dumy[ 1024 - 18 - ( sizeof(IR) * IR_COUNT ) - ( sizeof(PG) * PG_COUNT ) ];
} EEPMAP;

/* [N}N					*/
#define IS_LEAP_YEAR(y) ( (!(y % 400)) || ( (y % 100) && (!(y % 4)) ) )

/* 10msecJEgl`			*/
#define MS10COUNT ( (uint16_t)( ( F_CPU / 1024L ) / 100L ) )

/* O[oϐ錾				*/
#ifdef __MAIN_C__
volatile uint8_t RTC_TICK_MS10 = 0;			/* 10mseco߃tO				*/
uint8_t tickSec = 0;						/* bωtO					*/
uint8_t pgFlag[PG_COUNT];					/* vOtO				*/
uint32_t backupSerial = 0L;					/* obNAbv				*/

#else
extern volatile uint8_t RTC_TICK_MS10;
extern uint8_t tickSec;
extern uint8_t pgFlag[];
extern uint32_t backupSerial;
#endif

/*									*/
/* ֐vg^Cv錾				*/
/*									*/

/* ir.c								*/
void ir_init( uint16_t freq );
void ir_output( IR *ir );
uint8_t ir_input( IR *ir );
uint8_t ir_comper( IR *ir1 ,IR *ir2 );

/* date.h							*/
void RTC_init( void );
void RTC_set( TIME *t );
void RTC_get( TIME *t );
void RTC_convTime( uint32_t serial ,TIME *t );
uint32_t RTC_convSerial( TIME *t );
uint32_t RTC_getSerial( void );
uint32_t date_greg2mjd( uint16_t year ,uint8_t month ,uint8_t day );
void date_mjd2greg( uint32_t mjd ,uint16_t *year ,uint8_t *month ,uint8_t *day ,uint8_t *wday );
uint8_t date_daysOfMonth( uint16_t year ,uint8_t month );
void date_stepValue( TIME *t ,uint8_t index ,uint8_t dir );

/* system.c							*/
void eep_format( void );
uint8_t eep_check( void );
void eep_pgRead( uint8_t index ,PG *pg );
void eep_pgWrite( uint8_t index ,PG *pg );
void eep_irRead( uint8_t index ,IR *ir );
void eep_irWrite( uint8_t index ,IR *ir );

/* strings.h						*/
void Uint16ToString( char *buf ,uint16_t val ,uint8_t len ,char c );
void Uint16ToHex( char *buf ,uint16_t val ,uint8_t len ,char c );

/* draw.c							*/
void drawDate( uint8_t x ,uint8_t y ,TIME *t );
void drawTime( uint8_t x ,uint8_t y ,TIME *t );
void drawDateItems( uint8_t x ,uint8_t y ,TIME *t ,uint8_t index );
void drawMessageImage( const prog_uint8_t *img ,uint8_t width ,uint8_t height ,uint8_t t );
void drawTitleImage( const prog_uint8_t *img ,uint8_t width ,uint8_t height ,uint8_t pos );

/* progtime.c						*/
void progTimerPoll( void );
void progInitExecFlag( void );

/* menu001.c						*/
uint8_t menu001( void );

/* menu002.c						*/
uint8_t menu002( void );

/* menu003.c						*/
uint8_t menu003( void );

/* menu004.c						*/
uint8_t menu004( void );

/* menu005.c						*/
uint8_t menu005( void );

#endif
